//+------------------------------------------------------------------+
//|                                                      Queensha GD |
//|                                      Copyright 2018, Queensha GD |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright     "2018 - Queensha GD"
#property link          "https://www.mql5.com"
#property version       "1.0"
#property description   "My First EA"
#property strict
//+------------------------------------------------------------------+
//| ENUM : Option                                                    |
//+------------------------------------------------------------------+
  enum Option
    {
      On  = 1,  //  Enable
      Off = 0,  //  Disable
    };
//+------------------------------------------------------------------+
//| Input : Main Menu                                                |
//+------------------------------------------------------------------+
  input Option  binAuLots     = On;             // ----- [Lot Automatic] ::>>
  extern double binLots       = 0.01;           // ----- Volume Lot
  extern int    binTakeProfit = 99;             // ----- Take Profit
  extern int    binStopLoss   = 99;             // ----- Stop Loss
   int     binSlip            = 11;             // ----- Slippage
  extern int    binSpread     = 22;             // ----- Spread Limit
   int binPeriodMALops        = 33;             // ----- [Peroid] | Envelopes
   double  binLopsDev         = 0.03;           // ----- [Envelopes] | Deviation
  extern int    binMagic      = 666999;         // ----- Magic Number
   string  binBotName         = "Queensha GD";  // ----- Robot Comment
  extern string binWorkHours  = "3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22";    // ----- [Working Hours]
//+------------------------------------------------------------------+
//| Global Variable ::>>                                             |
//+------------------------------------------------------------------+
const string RobotName  = "Queensha GD";
double UpEnvelopes, LowEnvelopes;
double bonAutoLot;
double getOpenPrice, getOpenLots;
int workingHoursActual[24];
int getSpread;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   getSpread=(int)MarketInfo(Symbol(),MODE_SPREAD);
   getWorkingHours();
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   getInfoAccount();
   //---
      if(getWorkHours()==true)  {
        getIndicator();
        getAutoLot();
        getDotrades();
      }

  }
//+------------------------------------------------------------------+
//++++++++++++++++++++++<<:: START THE CODE ::>>++++++++++++++++++++++
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                       Checking Indicator ::>>    |
//+------------------------------------------------------------------+
  void getIndicator()  {
    UpEnvelopes = iEnvelopes(Symbol(),PERIOD_CURRENT,binPeriodMALops,MODE_EMA,0,PRICE_CLOSE,binLopsDev,MODE_UPPER,0);
    LowEnvelopes = iEnvelopes(Symbol(),PERIOD_CURRENT,binPeriodMALops,MODE_EMA,0,PRICE_CLOSE,binLopsDev,MODE_LOWER,0);
  }
//--- End of Checking Indicator
//+------------------------------------------------------------------+
//|                                          Checking Signal ::>>    |
//+------------------------------------------------------------------+
  bool getSignalBuy()  {
    double bdPrice  = Ask;
    //---
    if(bdPrice<LowEnvelopes)
      return(true);
  return(false);
  }
  //---
  bool getSignalSell()  {
    double bdPrice = Bid;
    //---
    if(bdPrice>UpEnvelopes)
      return(true);
  return(false);
  }
//--- End of Checking Signal
//+------------------------------------------------------------------+
//|                              Checking if any Open Trades ::>>    |
//+------------------------------------------------------------------+
  int getCheckingtrades() {
    int getTicketCount = 0;
      for(int getTicket=OrdersTotal()-1; getTicket>=0; getTicket--) {
        bool bdTicket=OrderSelect(getTicket,SELECT_BY_POS,MODE_TRADES);
        if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=binMagic) continue;
        if(OrderSymbol()==Symbol() && OrderMagicNumber()==binMagic)
          if(OrderType()==OP_SELL || OrderType()==OP_BUY) getTicketCount++;
      }
    return (getTicketCount);
  }
//--- End of Checking if any Open Trades
//+------------------------------------------------------------------+
//|                                      Checking MM AutoLot ::>>    |
//+------------------------------------------------------------------+
  void getAutoLot() {
    if(binAuLots==TRUE) {
      if(MathCeil(AccountBalance())<50.0) bonAutoLot=binLots;
      else bonAutoLot=0.00100*MathCeil(AccountBalance());
    }
    else bonAutoLot=binLots;
  }
//--- End of Checking MM AutoLot
//+------------------------------------------------------------------+
//|                                        Do Target Reached ::>>    |
//+------------------------------------------------------------------+
/*
  - Adding Daily Target Reached in Money or Percent (Optional Input), if target reached EA STOP Work, and continue tomorrow
  - Adding Close Profit in Money or Percent (Optional Input), if Conditon Loss in Money or Percent Reached, 
    do close then EA STOP work and continue tomorrow
*/
//--- End of Do Target Reached
//+------------------------------------------------------------------+
//|                                          FFC Filter News ::>>    |
//+------------------------------------------------------------------+
/*
  - Adding News Filter from Indicator FFC. FFC Indicator Build inside this EA
  - Event News Displayed in chart around 10 list
  - Create sample adding news filter. ex. filtering event news Non-Farm (NFP). 
    EA Stop work 30 minutes before news and continue work 60 minutes after news.
*/
//--- End of FFC Filter News
//+------------------------------------------------------------------+
//|                                                Do Trades ::>>    |
//+------------------------------------------------------------------+
  void getDotrades()  {
    if(Volume[0]>0)  {
      if(getCheckingtrades()==0)  {
        if(getSignalBuy()==true && getSpread<binSpread)  {
          int bdTicket = OrderSend(Symbol(),OP_BUY,bonAutoLot,Ask,binSlip,0,0,binBotName,binMagic,0,Lime);
          Print("<<-Order BUY Placed Successfull->>");
          getDoModify();
        }
        if(getSignalSell()==true && getSpread<binSpread) {
          int bdTicket = OrderSend(Symbol(),OP_SELL,bonAutoLot,Bid,binSlip,0,0,binBotName,binMagic,0,DodgerBlue);
          Print("<<-Order SELL Placed Successfull->>");
          getDoModify();
        }
      }
    }
  }
//--- End of Do Trades
//+------------------------------------------------------------------+
//|                                                Do Modify ::>>    |
//+------------------------------------------------------------------+
  void getDoModify()  {
    //---
    for(int index=OrdersTotal()-1; index>=0; index--)   {
      if(OrderSelect(index,SELECT_BY_POS,MODE_TRADES)) {
      if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=binMagic) continue;
        if(OrderSymbol()==Symbol() && OrderMagicNumber()==binMagic)   {
          if(OrderType()==OP_BUY) {
            getOpenPrice = OrderOpenPrice();
            double getTakeProfitBuy = NormalizeDouble(getOpenPrice+binTakeProfit*Point(),Digits);
            double getStopLossBuy = NormalizeDouble(getOpenPrice-binStopLoss*Point(),Digits);
            bool bdTicket = OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),getTakeProfitBuy,0,Yellow);
            Print("<<-Modify Static Take Profit BUY Successfull->>");
          }
          if(OrderType()==OP_SELL)  {
            getOpenPrice = OrderOpenPrice();
            double getTakeProfitSell = NormalizeDouble(getOpenPrice-binTakeProfit*Point(),Digits);
            double getStopLossSell = NormalizeDouble(getOpenPrice+binStopLoss*Point(),Digits);
            bool bdTicket = OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),getTakeProfitSell,0,Yellow);
            Print("<<-Modify Static Take Profit SELL Successfull->>");
          }
        }
      }
    }
  }
//--- End of Do Modify
//+------------------------------------------------------------------+
//|                                  Calling Global Function ::>>    |
//+------------------------------------------------------------------+
  void getGlobalCalling() {
  
  }
//--- End of Calling Global Function
//+------------------------------------------------------------------+
//|                                             Account Info ::>>    |
//+------------------------------------------------------------------+
  void getInfoAccount()  {
    string ShowComment="";
    ShowComment+="----------------------------------------------------------------------------------- \n"+
                "                       "+RobotName+"                             \n"+
                "----------------------------------------------------------------------------------- \n"+
                " Account Name        : "+AccountName()+"\n"+
                " Account Number      : "+IntegerToString(AccountNumber())+"\n"+
                " Account Leverage    : 1:"+IntegerToString(AccountLeverage())+"\n"+
                " Account Broker       : "+AccountCompany()+"\n"+
                "----------------------------------------------------------------------------------- \n"+
                " Account Balance     : "+AccountCurrency()+" "+DoubleToStr(AccountBalance(),2)+"\n"+
                " Account Equity      : "+AccountCurrency()+" "+DoubleToStr(AccountEquity(),2)+"\n"+
                "----------------------------------------------------------------------------------- \n"+
                //" [Entry Trigger Signal]  :  "+SignalComment+"      \n"+
                "----------------------------------------------------------------------------------- \n";
    Comment(ShowComment);
  }
//--- End of Account Info
//+------------------------------------------------------------------+
//|                                            Working Hours ::>>    |
//+------------------------------------------------------------------+
// Please fix my working horus... it seems not working when i test...
  void getWorkingHours()  {
    // Initialize
    ArrayInitialize(workingHoursActual, -1);
    // New string
    string workingHoursActualString[];
    // Fill
    int splitActual = StringSplit(binWorkHours, StringGetChar(",", 0), workingHoursActualString);
    for(int i = 0; i < ArraySize(workingHoursActualString); i++) {
      workingHoursActual[i] = (int)StringToInteger(workingHoursActualString[i]);
    }
  }
  //---
  bool getWorkHours() {
    // Check for hour in actual
    for(int i = 0; i < ArraySize(workingHoursActual); i++) {
      if(workingHoursActual[i] == TimeHour(TimeCurrent()))
        return (true);
    }
    return (false);
  }
//--- End of Working Hours
//+------------------------------------------------------------------+
//+++++++++++++++++++++++<<:: END OF CODE ::>>++++++++++++++++++++++++
//+------------------------------------------------------------------+
//|                                         Sample Templates ::>>    |
//+------------------------------------------------------------------+

//--- End of Sample Templates